#include "debug.h"

#define Size   7
#define Tize   6
#define RXAdderss   0x02
#define TxAdderss   0x02

u8 TxData[Size] = { 0x01, 0x02, 0x03, 0x04, 0x05, 0x00 };
u8 RxData[Size];

void IIC_Init(u32 bound, u16 address) {
    GPIO_InitTypeDef GPIO_InitStructure;
    I2C_InitTypeDef I2C_InitTSturcture;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB | RCC_APB2Periph_AFIO, ENABLE);
    GPIO_PinRemapConfig(GPIO_Remap_I2C1, ENABLE); //ӳ书ܣPB8PB9ӳΪI2C1
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_I2C1, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOB, &GPIO_InitStructure);

    I2C_InitTSturcture.I2C_ClockSpeed = bound;    //I2C
    I2C_InitTSturcture.I2C_Mode = I2C_Mode_I2C;   //ָI2Cģʽ
    I2C_InitTSturcture.I2C_DutyCycle = I2C_DutyCycle_16_9; //ָʱռձ
    I2C_InitTSturcture.I2C_OwnAddress1 = address; //ָI2C豸ַ
    I2C_InitTSturcture.I2C_Ack = I2C_Ack_Enable;  //ʹܻ߹رӦ (һ㶼ʹ)
    I2C_InitTSturcture.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit; //ַָĳ,7λ10λ
    I2C_Init( I2C1, &I2C_InitTSturcture);
    I2C_DMACmd( I2C1, ENABLE);

    I2C_Cmd( I2C1, ENABLE);
    I2C_AcknowledgeConfig( I2C1, ENABLE);
}

void DMA_Tx_Init(DMA_Channel_TypeDef* DMA_CHx, u32 ppadr, u32 memadr,
        u16 bufsize) {
    DMA_InitTypeDef DMA_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE); //ʹDMA1ʱ
    DMA_DeInit(DMA_CHx);
    DMA_InitStructure.DMA_PeripheralBaseAddr = ppadr;    //ַ
    DMA_InitStructure.DMA_MemoryBaseAddr = memadr;       //ô洢ַ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;   //ô䷽򣺴洢
    DMA_InitStructure.DMA_BufferSize = bufsize;          //ôС
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;  //ַָ
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;          //ָ洢ַ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݵλ
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;  //ô洢ݵλ
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;            //öӦDMAģʽΪģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;  //DMA1ͨ6ȼ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;           //ֹʹDMA洢洢Ĵ䷽ʽ
    DMA_Init(DMA_CHx, &DMA_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel6_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    DMA_ITConfig( DMA1_Channel6, DMA_IT_TC, ENABLE);
}

void DMA1_Channel6_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void DMA1_Channel6_IRQHandler() {
    if (DMA_GetITStatus(DMA1_IT_TC6) != RESET) {
        DMA_Cmd( DMA1_Channel6, DISABLE);
        DMA_ClearITPendingBit(DMA1_IT_TC6);
    }
}

int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("IIC Host mode\r\n");
    //DMAʼ
    DMA_Tx_Init( DMA1_Channel6, (u32) &I2C1->DATAR, (u32) TxData, Tize);
    IIC_Init(10000, TxAdderss);   //I2Cʼ
    while(1) {
       DMA_Cmd(DMA1_Channel6, DISABLE);                // رDMA1_Channel6ٷ
     //   I2C_GenerateSTART( I2C1, ENABLE );
        TxData[6] = TxData[6] + 1;
             if(TxData[6] > 230) {
                 TxData[6] = 0;
             }
        while( I2C_GetFlagStatus( I2C1, I2C_FLAG_BUSY ) != RESET ); //ǷָI2C־
        I2C_GenerateSTART( I2C1, ENABLE );//  //I2C1ͨʼź
        //һ¼ΪI2C_EVENT_MASTER_MODE_SELECT¼ʱ˵ѡI2CΪģʽwhileѭһ
        while( !I2C_CheckEvent( I2C1, I2C_EVENT_MASTER_MODE_SELECT ) );//һI2Cx¼ǷΪݵ¼
        //͵ַѡӻ豸
        I2C_Send7bitAddress( I2C1, 0x02, I2C_Direction_Transmitter );
        //һ¼ΪI2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED¼ʱ˵ѡI2Cͣwhileѭһݷ
        while( !I2C_CheckEvent( I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED ) );
        DMA_Cmd( DMA1_Channel6, ENABLE );  //  //ʹܿDMA1ͨ6ݷ
        //һ¼ΪI2C_EVENT_MASTER_BYTE_TRANSMITTED¼ʱ˵ͽwhileѭһ
        while( !I2C_CheckEvent( I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED ) );
        I2C_GenerateSTOP( I2C1, ENABLE );  // //I2Cֹͨͣź

        printf(" ***************************  \r\n");
        Delay_Ms(500);
    }
}

